# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
from datetime import datetime
from dateutil.relativedelta import relativedelta
from tools.translate import _
import netsvc

class mrp_fixed_cost(osv.osv):
    _inherit = 'mrp.fixed.cost'
    _name = 'mrp.fixed.cost'
    _description = 'MRP fixed costs'               
#
#    def change_name(self, cr, uid, ids, name):
#        me = self.browse(cr, uid, ids)[0]
#        if True  :
#                warning = {
#                    'title': _('Warning!'),
#                    'message': _('Not allowed to change the name of fixed costs!')
#                        }
#                return { 'warning': warning}
#        else:
#            return {'value':{'created':True}}

    def unlink(self, cr, uid, ids, context=None):
        if 'borrar' in context:
            super(mrp_fixed_cost, self).unlink(cr, uid, ids, context=context)    
        else:
            raise osv.except_osv(_('Unable to perform action'), _('Not allowed to delete the fixed costs, set its quantity to 0!'))
        return True

    def write(self, cr, uid, ids, vals, context=None):
        fix = self.browse(cr, uid, ids, context)
        if vals['name'] <> fix[0].name:
            raise osv.except_osv(_('Unable to perform action'), _('Not allowed to change the name of fixed costs!'))
        res = super(mrp_fixed_cost, self).write(cr, uid, ids, vals, context=context)        
        
        account_analytic_line_obj = self.pool.get('account.analytic.line')
        account_analytic_obj = self.pool.get('account.analytic.account')
        
        for cost in fix:
                fix_acc_search = account_analytic_obj.search(cr, uid, [('code','=','OF'+str(cost.production_id.id)+ "FIX" )])
                if fix_acc_search:
                    line_search = account_analytic_line_obj.search(cr, uid, [('name','=',cost.name),('account_id','=',fix_acc_search[0])])
                    if line_search:
                        print 'name '+str(cost.name)+' ip '+ str(fix_acc_search[0])
                        account_analytic_line_obj.write(cr, uid, line_search[0],{'amount':(cost.amount*(-1))})                                                 
                        account_analytic_obj.recalculate_result(cr, uid, fix_acc_search[0])
                    else:
                        print 'fallo de programacion al leer la linea de cuenta analitica'
                else:
                        print 'Analitica no creada o fallo de programacion al leer la cuenta analitica' 
        return res
    
    def create(self, cr, uid, vals, context=None):
        fix_created = super(mrp_fixed_cost, self).create(cr, uid, vals, context=context)        
        account_analytic_obj = self.pool.get('account.analytic.account')
        account_analytic_jour_obj = self.pool.get('account.analytic.journal')
        acc_search = account_analytic_obj.search(cr, uid,[('code','=','OF'+str(vals['production_id']))])
        acc_id = False
        if acc_search:
            acc_id = acc_search[0]
        
        man_journal_search = account_analytic_jour_obj.search(cr, uid,[('name', '=', 'Manufacturing')])        
        
        if acc_id:
           
           account_analytic_line_obj = self.pool.get('account.analytic.line')
           op_acc_code = False
           prod_maq_name_acc_code = False
            
           man_fix_account = account_analytic_obj.search(cr, uid,[('code','=','OF'+str(vals['production_id'])+'FIX') ] )[0]
           
           if not man_fix_account:         
                    #Crear cuenta analitica de costes fijos                   
               
                   
         
               op_acc_code = 'OF' + str(acc_id)
               prod_maq_name_acc_code = op_acc_code + 'FIX'
                        
               est = 0
                                                
               values={
                    'name':prod_maq_name_acc_code + " " + 'Fijos ' ,
                    'code':prod_maq_name_acc_code ,
                    'currency_id':1,
                    'company_id':1,
                    'state':'open',
                    'parent_id':acc_id,
                    'total_estimated':est,
                    'acc_type':'FIX'
                  }
                            
                            
               man_fix_account = account_analytic_obj.create(cr, uid, values)
               account_analytic_obj.recalculate_result(cr, uid, man_fix_account) 
                            
          
                            #añadir costes reales de costes fijos                        
                                
           values = {
               'amount':vals['amount']*(-1),
               'name':vals['name'],
               'date':datetime.today(),
               'company_in':1,
               'account_id': man_fix_account,
               'general_account_id':950,
               'journal_id':man_journal_search[0],
                 }
                    
           new_id = account_analytic_line_obj.create(cr, uid, values)          
           account_analytic_obj.recalculate_result(cr, uid, man_fix_account)        
                    
        return True
    
mrp_fixed_cost()